<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>B-Spline Test</title>

    <script src="js/canvas.js"></script>
    <script src="js/spline.js"></script>
    <style>
      * { box-sizing: border-box; }
      :root { font-family: sans-serif; font-size: 62.5%; }
      body { margin: 0; font-size: 1.4rem; }
      footer { padding: 5px; background: #eee; }
      ul { margin: 0; }
      .container { display: flex; flex-direction: column; height: 100vh; gap: 5px; }
      .fill { flex: 1; }
      #canvas { display: block; }
    </style>
  </head>
  <body class="container">
    <div class="fill"><canvas id="canvas"></canvas></div>
    <!-- <footer>
      References:
      <ul>
        <li><a href="https://ciechanow.ski/curves-and-surfaces/">Curves and Surfaces (Bartosz Ciechanowski)</a></li>
        <li><a href="https://mathworld.wolfram.com/B-Spline.html">B-Spline (Wolfram MathWorld)</a></li>
        <li><a href="https://inconvergent.net/generative/sand-spline/">Sand Spline (inconvergent)</a></li>
      </ul>
    </footer> -->

    <script>
      // prepare canvas
      const canvas = new Canvas('canvas')

      // define vars
      const cps = Math.floor(canvas.w / 180) // number of control points
      const pad = { x: 250, y: 100 } // padding around the 'safe' area
      const min = { x: pad.x, y: pad.y } // minimum coords
      const max = { x: canvas.w - pad.x, y: canvas.h - pad.y } // maximum coords
      const c = { x: (max.x + min.x) / 2, y: (max.y + min.y) / 2 } // center of the canvas
      // distances between equally spaced control points
      const d = {
        x: (max.x - min.x) / (cps - 1),
        y: (max.y - min.y) / (cps - 1),
        r: (Math.PI * 2) / (cps - 1),
      }
      const r = Math.min(max.x - min.x, max.y - min.y) / 2 // circle radius

      // define the spline
      const spline = new Spline(
        // horizontal line
        // [...new Array(cps)].map((_, i) => [(i * d.x) + min.x, c.y]),
        // vertical line
        // [...new Array(cps)].map((_, i) => [c.x, (i * d.y) + min.y]),
        // diagonal line (top-left to bottom-right)
        // [...new Array(cps)].map((_, i) => [(i * d.x) + min.x, (i * d.y) + min.y]),
        // diagonal line (bottom-left to top-right)
        // [...new Array(cps)].map((_, i) => [((cps - i - 1) * d.x) + min.x, (i * d.y) + min.y]),
        // circle
        // [...new Array(cps)].map((_, i) => [Math.sin(i * d.r) * r + c.x, -Math.cos(i * d.r) * r + c.y]),
        // random
        // [...new Array(cps)].map((_, i) => [randInt(max.x, min.x), randInt(max.y, min.y)]),
        // horizontal squiggle
        [...new Array(cps)].map((_, i) => [(i * d.x) + min.x + randInt(50, -50), c.y + randInt(50, -50)]),
        // vertical squiggle
        // [...new Array(cps)].map((_, i) => [c.x + randInt(50, -50), (i * d.y) + min.y + randInt(50, -50)]),
      )

      // canvas.ctx.strokeStyle = 'black'
      // canvas.ctx.lineWidth = 2
      // canvas.ctx.rect(min.x, min.y, max.x - min.x, max.y - min.y)
      // canvas.ctx.stroke()

      // every iteration, move the control points randomly and re-draw the points along the spline
      const v = { x: 10, y: 20 }
      const iters = 300
      spline.draw(canvas, { control: false })
      for (let i = 0; i < iters; i++) {
        spline.control = spline.control.map(([x, y], j) => [x + randInt(v.x, -v.x), y + randInt(v.y, -v.y)])
        spline.draw(canvas, { n: randInt(200, 100) })
      }

      // utils
      function randInt(max, min = 0) {
        return Math.floor(Math.random() * (max - min + 1)) + min
      }
    </script>
  </body>
</html>